	include "ramdat.asm"
			  dc.l $FFFFFE,   start,     ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l HBlank,    ErrorTrap, VBlank,    ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.b "SEGA MEGASIS    "
              dc.b "(C)2015.OCT JAL "
              dc.b "Halloween demo                                  "
              dc.b "Halloween demo                                  "
              dc.b "GM 01234567-89"
              dc.w $DEAD        ;checksum
              dc.b "J               "
              dc.l 0
              dc.l ROM_End
              dc.l $FF0000
              dc.l $FFFFFF
              dc.b "    "
              dc.b "    "
              dc.b "    "
              dc.b "            "                           
              dc.b "This program contains blast processing! "
              dc.b "JUE             "
                          
start:        
		move.b  $A10001,d0
        andi.b  #$0F,d0
        beq.b   no_tmss       ;branch if oldest MD/GEN
        move.l  #'SEGA',$A14000 ;satisfy the TMSS        

no_tmss:
		move.w #$2700,sr
        bsr clear_regs
		bsr clear_ram
		bsr setup_vdp		
		bsr clear_vram	
        move.l #$40000010,(a3)   ;write to vsram    
		move.w #$0000,(a4)	     ;reset scroll for both layers
		move.w #$0000,(a4)		
		move.b #$01,currentcolor
		
		lea (font),a5
		lea (Dec_loc),a1
		bsr decompress	
		lea (Dec_loc),a5
		move.w #$07FF,d4
		move.l #$40000000,(a3)
		bsr vram_loop

		lea (electrode),a5
		lea (Dec_loc),a1
		bsr decompress			
		lea (Dec_loc),a5
		move.w #$00BF,d4
		move.l #$50000000,(a3)
		bsr vram_loop
		
		lea (zap),a5
		move.w #$0010,d4
		bsr vram_loop	
		
		lea (background),a5
		lea (Dec_loc),a1
		bsr decompress
		lea (Dec_loc),a5
		move.w #$4600,d4
		move.l #$58000000,(a3)
		bsr vram_loop	

		lea (music),a5
		lea (Dec_loc),a1
		bsr decompress

		lea (wave),a5
		lea (wave_loc),a1
		bsr decompress			
		
		bsr generate_map
		
		lea (message),a5
		move.l #$40880003,(a3) ;vram C088
		bsr termtextloop

		lea (palette),a5
		move.w #$0036,d4
		move.l #$c0000000,(a3)
		bsr vram_loop	

		bsr setup_sprites
		bsr load_arc
		move.w #$0002,d7 ;animate speed
		
		lea (Dec_loc)+40,a0
		move.w #$100,($A11100)
		move.w #$100,($A11200)
		move.w #$2300,sr
		
loop:
		bra loop
		
clear_ram:
		move.w #$7FF0,d0
		move.l #$FF0000,a0	
clear_ram_loop:
		move.w #$0000,(a0)+
		dbf d0, clear_ram_loop
		rts
clear_vram:
		move.l #$40000000,(a3)
		move.w #$7fff,d4
vram_clear_loop:
		move.w #$0000,(a4)
		dbf d4, vram_clear_loop
		rts	
	
setup_vdp:
	    lea    $C00000.l,a4     ;VDP data port
	    lea    $C00004.l,a3
        lea    (VDPSetupArray).l,a5
        move.w #0018,d4         ;loop counter
VDP_Loop:
        move.w (a5)+,(a3)       ;load setup array
	    nop
        dbf d4,VDP_Loop
        rts 	
vram_loop:
        move.w (a5)+,(a4)
        dbf d4,vram_loop
        rts 			
	    
clear_regs:
        moveq #$00000000,d0
        moveq #$00000000,d1
        moveq #$00000000,d2
        moveq #$00000000,d3
        moveq #$00000000,d4
        moveq #$00000000,d5
        moveq #$00000000,d6
        moveq #$00000000,d7
		move.l d0,a0
		move.l d0,a1
		move.l d0,a2
		move.l d0,a3
		move.l d0,a4
		move.l d0,a5
		move.l d0,a6
        rts
		
calc_vram:
		move.l d1,-(sp)
		move.l d0,d1
		andi.w #$C000,d1 ;get first two bits only
		lsr.w #$7,d1     ;shift 14 spaces to move it to the end
		lsr.w #$7,d1     ;ditto
		andi.w #$3FFF,d0 ;clear all but first two bits
		eor.w #$4000,d0  ;attach vram write bit
		swap d0          ;move d0 to high word
		eor.w d1,d0      ;smash the two halves together	
		move.l (sp)+,d1
		rts			
		
load_arc:
		move.l #$0000E186,d1
		move.w #$0013,d4
		bsr arcloop
		move.l #$0000E1C6,d1
		move.w #$0014,d4
		bsr arcloop		
		rts
arcloop:
		move.w #$008C,(a4)
		add.l #$0080,d1
		move.l d1,d0
		bsr calc_vram
		move.l d0,(a3)
		dbf d4,arcloop
		rts
	
setup_sprites:
		move.l #$78000003,(a3)
		move.w #$013E,(a4)
		move.w #$0B01,(a4)
		move.w #$2080,(a4)
		move.w #$0094,(a4)
		
		move.w #$0082,(a4)
		move.w #$0B02,(a4)
		move.w #$3080,(a4)
		move.w #$0094,(a4)	

		move.w #$0082,(a4)
		move.w #$0B03,(a4)
		move.w #$3080,(a4)
		move.w #$0194,(a4)

		move.w #$013E,(a4)
		move.w #$0B00,(a4)
		move.w #$2080,(a4)
		move.w #$0194,(a4)		
		rts
		
generate_map:                  ;generate a map for 320x224 images
        move.l #$40C0,d0         ;first tile
        move.w #$001c,d5
        move.l #$40000003,(a3) ;vram write to $C000	   
superloop:
        move.w #$27,d4
maploop:
        move.w d0,(a4)
        add.w #$1,d0
        dbf d4,maploop
        move.w #$17,d4
maploop2:
        move.w #$00,(a4)
        dbf d4,maploop2
        dbf d5,superloop
        rts
		
termtextloop:					;for strings with terminators
		move.b (a5)+,d4	
		cmpi.b #$24,d4			;$ (end of text flag)
		beq return
		andi.w #$00ff,d4
		eor.w #$6000,d4
        move.w d4,(a4)		
		bra termtextloop		
		
ErrorTrap:        
        nop
        bra ErrorTrap


HBlank:
		move.l #$70000003,(a3)
		move.b (a6),d6	
		add.l #$00000004,a6
		lsr.b #$05,d6
		move.w d6,(a4)
        rte

VBlank:
		bsr calc_raster 
        bsr playmusic
		bsr check_color
        rte
	
check_color
		cmpi.b #$ff,colorflag
		bne return
		move.l #$C0000000,(a3)	
		move.b #$00,colorflag	
		
		add.b #$01, currentcolor	
		cmpi.b #$06,currentcolor
		bgt resetcolor	
		
ret0:		
		lea (colortable),a2
		moveq #$00000000,d0
		move.b currentcolor,d0
        lsl.b #$1,d0		    ;locate the correct table
		sub.w #$02,d0           ;step back a word 
		add.w d0,a2             ;adjust the address register 
		move.w (a2),d0
		move.l d0,a2            ;switch to direct addressing 
		jmp (a2)
		
resetcolor:
		move.b #$01,currentcolor
		bra ret0
		
colortable:	
	dc.w setblue	
	dc.w setgreen
	dc.w setred	
	dc.w setwhite
	dc.w setviolet
	dc.w setyellow
		
setblue:	
		move.w #$0000,(a4)
		move.w #$0E00,(a4)
		move.w #$0A00,(a4)
		rts
setgreen:		
		move.w #$0000,(a4)
		move.w #$00E0,(a4)
		move.w #$00A0,(a4)
		rts
setred:		
		move.w #$0000,(a4)
		move.w #$000E,(a4)
		move.w #$000A,(a4)
		rts		
setwhite:		
		move.w #$0000,(a4)
		move.w #$0EEE,(a4)
		move.w #$0AAA,(a4)
		rts	
setviolet:		
		move.w #$0000,(a4)
		move.w #$0E0E,(a4)
		move.w #$0A0A,(a4)
		rts			
setyellow:		
		move.w #$0000,(a4)
		move.w #$00EE,(a4)
		move.w #$00AA,(a4)
		rts		
		
calc_raster:
		cmpi.w #$1EA0, music_counter ;change speed at 1EA0
		blt slow
        add.w d7, rastervblanks	 ;animation speed (pixels per VB)
slow:		
        add.w d7, rastervblanks  ;add twice for higher speed
	    cmpi.w #$004A,rastervblanks
	     bge reset_vb
	    lea (wave_loc),a6
	    add.w rastervblanks,a6
	    rts	
reset_vb:
	    move.w #$0000,rastervblanks
	    bra calc_raster	
	
return:
		rts

	include "music_driver.asm"
	include "decompress.asm"
	
VDPSetupArray:
	dc.w $8014		
	dc.w $8174  ;Genesis mode, DMA enabled, VBLANK-INT enabled		
	dc.w $8238	;field A    
	dc.w $8300	;$833e	
	dc.w $8406	;field B	
	dc.w $857c	;sprite
	dc.w $8600
	dc.w $8700  ;BG color		
	dc.w $8800
	dc.w $8900
	dc.w $8A00	
	dc.w $8B00		
	dc.w $8C81	
	dc.w $8D3C		
	dc.w $8E00
	dc.w $8F02	;auto increment	
	dc.w $9001		
	dc.w $9100		
	dc.w $9200
	
palette:
	dc.w $0000,$0E00,$0A00,$0000,$0000,$0000,$0000,$0000 ;arc
	dc.w $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000

	dc.w $0000,$0CCC,$0AAA,$0EEE,$026E,$0666,$0008,$000C ;sprites
	dc.w $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000

	dc.w $0000,$000C,$000E,$0CCC,$0AAA,$04E0,$0E40,$0EEE ;9-11 left. 10-12 mid. 14-15 Right.
	dc.w $0C0C,$048C,$0E0E,$0248,$040E,$00AC,$00EE,$0000 ;BG
	
	dc.w $0000,$0000,$0000,$0EEE,$0000,$0000,$0000,$0000 ;text
	
message:
	dc.b "        Happy Halloween!"
	dc.b "                                            "
	dc.b " Made by ComradeOj ", $7F, "2015$ "


font:
	;incbin "gfx/ascii.bin"	
	incbin "gfx/ascii.kos"	
electrode:
	;incbin "gfx/electrode.bin"
	incbin "gfx/electrode.kos"
zap:
	incbin "gfx/zap.bin"	
background	
	incbin "gfx/background.kos"
	;incbin "gfx/background.bin"
	
wave:
	incbin "Triangle.kos"
	;incbin "Triangle.bin"

music:
    incbin "robotv2.kvgm"
    ;incbin "robot.vgm"
	
ROM_End:
              
              